#include <sh/reg704x.h>
static void (*int_proc[60])();

int int_table_7045(int num) {
	int	index;

	index = -1;
	if(num == 4) {
		index = num - 4;
	} else if(num == 6) {
		index = num - 5;
	} else if(num >= 9 && num <= 12) {
		index = num - 7;
	} else if(num >= 32 && num <= 35) {
		index = num - 26;
	} else if(num >= 64 && num <= 72) {
		index = num - 54;
	} else if(num == 76) {
		index = num - 57;
	} else if(num == 80) {
		index = num - 60;
	} else if(num == 84) {
		index = num - 63;
	} else if(num >= 88 && num <= 92) {
		index = num - 66;
	} else if(num >= 96 && num <= 97) {
		index = num - 69;
	} else if(num >= 100 && num <= 101) {
		index = num - 71;
	} else if(num >= 104 && num <= 105) {
		index = num - 73;
	} else if(num >= 108 && num <= 109) {
		index = num - 75;
	} else if(num >= 112 && num <= 116) {
		index = num - 77;
	} else if(num >= 120 && num <= 124) {
		index = num - 80;
	} else if(num >= 128 && num <= 136) {
		index = num - 83;
	} else if(num == 140) {
		index = num - 86;
	} else if(num == 144) {
		index = num - 89;
	} else if(num == 148) {
		index = num - 92;
	} else if(num >= 152 && num <= 153) {
		index = num - 95;
	} else if(num == 156) {
		index = num - 97;
	}
	return index;
}

int int_regist(int num, void (*proc)()) {
	int	index;

	index = int_table_7045(num);
	if(index == -1) return -1;
	if(int_proc[index] != 0) return -1;
	int_proc[index] = proc;
	return 0;
}

int int_unregist(int num) {
	int	index;

	index = int_table_7045(num);
	if(index == -1) return -1;
	if(int_proc[index] == 0) return -1;
	int_proc[index] = 0;
	return 0;
}

#define DownEdge	1
#define UpEdge		2
void	nmi_edge(int edge) {
	if(edge == DownEdge) ICR &= ~0x100;
	else if(edge == UpEdge) ICR |= 0x100;
}

#pragma interrupt
void int_geninst() {
	if(int_proc[0] != 0) (*int_proc[0])();
}

#pragma interrupt
void int_slotinst() {
	if(int_proc[1] != 0) (*int_proc[1])();
}

#pragma interrupt
void int_cpuaddr() {
	if(int_proc[2] != 0) (*int_proc[2])();
}

#pragma interrupt
void int_dmaaddr() {
	if(int_proc[3] != 0) (*int_proc[3])();
}

#pragma interrupt
void int_nmi(){
	if(int_proc[4] != 0) (*int_proc[4])();
}

#pragma interrupt
void int_usrbreak(){
	if(int_proc[5] != 0) (*int_proc[5])();
}

#pragma interrupt
void int_trap0(){
	if(int_proc[6] != 0) (*int_proc[6])();
}

#pragma interrupt
void int_trap1(){
	if(int_proc[7] != 0) (*int_proc[7])();
}

#pragma interrupt
void int_trap2(){
	if(int_proc[8] != 0) (*int_proc[8])();
}

#pragma interrupt
void int_trap3(){
	if(int_proc[9] != 0) (*int_proc[9])();
}

#pragma interrupt
void int_irq0(){
	if(int_proc[10] != 0) (*int_proc[10])();
}

#pragma interrupt
void int_irq1(){
	if(int_proc[11] != 0) (*int_proc[11])();
}

#pragma interrupt
void int_irq2(){
	if(int_proc[12] != 0) (*int_proc[12])();
}

#pragma interrupt
void int_irq3(){
	if(int_proc[13] != 0) (*int_proc[13])();
}

#pragma interrupt
void int_irq4(){
	if(int_proc[14] != 0) (*int_proc[14])();
}

#pragma interrupt
void int_irq5(){
	if(int_proc[15] != 0) (*int_proc[15])();
}

#pragma interrupt
void int_irq6(){
	if(int_proc[16] != 0) (*int_proc[16])();
}

#pragma interrupt
void int_irq7(){
	if(int_proc[17] != 0) (*int_proc[17])();
}

#pragma interrupt
void int_dei0(){
	if(int_proc[18] != 0) (*int_proc[18])();
}

#pragma interrupt
void int_dei1(){
	if(int_proc[19] != 0) (*int_proc[19])();
}

#pragma interrupt
void int_dei2(){
	if(int_proc[20] != 0) (*int_proc[20])();
}

#pragma interrupt
void int_dei3(){
	if(int_proc[21] != 0) (*int_proc[21])();
}

#pragma interrupt
void int_tgi0a(){
	if(int_proc[22] != 0) (*int_proc[22])();
}

#pragma interrupt
void int_tgi0b(){
	if(int_proc[23] != 0) (*int_proc[23])();
}

#pragma interrupt
void int_tgi0c(){
	if(int_proc[24] != 0) (*int_proc[24])();
}

#pragma interrupt
void int_tgi0d(){
	if(int_proc[25] != 0) (*int_proc[25])();
}

#pragma interrupt
void int_tgi0v(){
	if(int_proc[26] != 0) (*int_proc[26])();
}

#pragma interrupt
void int_tgi1a(){
	if(int_proc[27] != 0) (*int_proc[27])();
}

#pragma interrupt
void int_tgi1b(){
	if(int_proc[28] != 0) (*int_proc[28])();
}

#pragma interrupt
void int_tgi1v(){
	if(int_proc[29] != 0) (*int_proc[29])();
}

#pragma interrupt
void int_tgi1u(){
	if(int_proc[30] != 0) (*int_proc[30])();
}

#pragma interrupt
void int_tgi2a(){
	if(int_proc[31] != 0) (*int_proc[31])();
}

#pragma interrupt
void int_tgi2b(){
	if(int_proc[32] != 0) (*int_proc[32])();
}

#pragma interrupt
void int_tgi2v(){
	if(int_proc[33] != 0) (*int_proc[33])();
}

#pragma interrupt
void int_tgi2u(){
	if(int_proc[34] != 0) (*int_proc[34])();
}

#pragma interrupt
void int_tgi3a(){
	if(int_proc[35] != 0) (*int_proc[35])();
}

#pragma interrupt
void int_tgi3b(){
	if(int_proc[36] != 0) (*int_proc[36])();
}

#pragma interrupt
void int_tgi3c(){
	if(int_proc[37] != 0) (*int_proc[37])();
}

#pragma interrupt
void int_tgi3d(){
	if(int_proc[38] != 0) (*int_proc[38])();
}

#pragma interrupt
void int_tgi3v(){
	if(int_proc[39] != 0) (*int_proc[39])();
}

#pragma interrupt
void int_tgi4a(){
	if(int_proc[40] != 0) (*int_proc[40])();
}

#pragma interrupt
void int_tgi4b(){
	if(int_proc[41] != 0) (*int_proc[41])();
}

#pragma interrupt
void int_tgi4c(){
	if(int_proc[42] != 0) (*int_proc[42])();
}

#pragma interrupt
void int_tgi4d(){
	if(int_proc[43] != 0) (*int_proc[43])();
}

#pragma interrupt
void int_tgi4v(){
	if(int_proc[44] != 0) (*int_proc[44])();
}

#pragma interrupt
void int_eri0(){
	if(int_proc[45] != 0) (*int_proc[45])();
}

#pragma interrupt
void int_rxi0(){
	if(int_proc[46] != 0) (*int_proc[46])();
}

#pragma interrupt
void int_txi0(){
	if(int_proc[47] != 0) (*int_proc[47])();
}

#pragma interrupt
void int_tei0(){
	if(int_proc[48] != 0) (*int_proc[48])();
}

#pragma interrupt
void int_eri1(){
	if(int_proc[49] != 0) (*int_proc[49])();
}

#pragma interrupt
void int_rxi1(){
	if(int_proc[50] != 0) (*int_proc[50])();
}

#pragma interrupt
void int_txi1(){
	if(int_proc[51] != 0) (*int_proc[51])();
}

#pragma interrupt
void int_tei1(){
	if(int_proc[52] != 0) (*int_proc[52])();
}

#pragma interrupt
void int_adi(){
	if(int_proc[53] != 0) (*int_proc[53])();
}

#pragma interrupt
void int_swetce(){
	if(int_proc[54] != 0) (*int_proc[54])();
}

#pragma interrupt
void int_cmi0(){
	if(int_proc[55] != 0) (*int_proc[55])();
}

#pragma interrupt
void int_cmi1(){
	if(int_proc[56] != 0) (*int_proc[56])();
}

#pragma interrupt
void int_iti(){
	if(int_proc[57] != 0) (*int_proc[57])();
}

#pragma interrupt
void int_cmi(){
	if(int_proc[58] != 0) (*int_proc[58])();
}

#pragma interrupt
void int_oei(){
	if(int_proc[59] != 0) (*int_proc[59])();
}

void int_init() {
	int	i;

	for(i = 0;i < 60;i++) int_proc[i] = 0;
}
