#include "regdef.h"

void bussize_setup(int enable, int disable) {
	ABWCR |= enable;
	ABWCR &= ~disable;
}

void cs_setup(int cs) {
	CSCR = cs;
	if(cs & 1) P8DDR |= 16;
	if(cs & 2) P8DDR |= 8;
	if(cs & 4) P8DDR |= 4;
	if(cs & 8) P8DDR |= 2;
}
