/* port address of internal registers */

#define FLMCR (*(volatile unsigned char *)0xffff40)
#define EBR1 (*(volatile unsigned char *)0xffff42)
#define EBR2 (*(volatile unsigned char *)0xffff43)
#define RAMCR (*(volatile unsigned char *)0xffff47)
#define SMR0 (*(volatile unsigned char *)0xffffb0)
#define BRR0 (*(volatile unsigned char *)0xffffb1)
#define SCR0 (*(volatile unsigned char *)0xffffb2)
#define TDR0 (*(volatile unsigned char *)0xffffb3)
#define SSR0 (*(volatile unsigned char *)0xffffb4)
#define RDR0 (*(volatile unsigned char *)0xffffb5)
#define SMR1 (*(volatile unsigned char *)0xffffb8)
#define BRR1 (*(volatile unsigned char *)0xffffb9)
#define SCR1 (*(volatile unsigned char *)0xffffba)
#define TDR1 (*(volatile unsigned char *)0xffffbb)
#define SSR1 (*(volatile unsigned char *)0xffffbc)
#define RDR1 (*(volatile unsigned char *)0xffffbd)

#define P1DDR (*(volatile unsigned char *)0xffffc0)
#define P1DR (*(volatile unsigned char *)0xffffc2)
#define P2DDR (*(volatile unsigned char *)0xffffc1)
#define P2DR (*(volatile unsigned char *)0xffffc3)
#define P2PCR (*(volatile unsigned char *)0xffffd8)
#define P3DDR (*(volatile unsigned char *)0xffffc4)
#define P3DR (*(volatile unsigned char *)0xffffc6)
#define P4DDR (*(volatile unsigned char *)0xffffc5)
#define P4DR (*(volatile unsigned char *)0xffffc7)
#define P4PCR (*(volatile unsigned char *)0xffffda)
#define P5DDR (*(volatile unsigned char *)0xffffc8)
#define P5DR (*(volatile unsigned char *)0xffffca)
#define P5PCR (*(volatile unsigned char *)0xffffdb)
#define P6DDR (*(volatile unsigned char *)0xffffc9)
#define P6DR (*(volatile unsigned char *)0xffffcb)
#define P7DR (*(volatile unsigned char *)0xffffce)
#define P8DDR (*(volatile unsigned char *)0xffffcd)
#define P8DR (*(volatile unsigned char *)0xffffcf)
#define P9DDR (*(volatile unsigned char *)0xffffd0)
#define P9DR (*(volatile unsigned char *)0xffffd2)
#define PADDR (*(volatile unsigned char *)0xffffd1)
#define PADR (*(volatile unsigned char *)0xffffd3)
#define PBDDR (*(volatile unsigned char *)0xffffd4)
#define PBDR (*(volatile unsigned char *)0xffffd6)
#define TCNT_WR (*(volatile unsigned short *)0xffffa8)
#define TCSR_WR (*(volatile unsigned short *)0xffffa8)
#define TCNT_RD (*(volatile unsigned char *)0xffffa8)
#define TCSR_RD (*(volatile unsigned char *)0xffffa9)

#define MDCR (*(volatile unsigned char *)0xfffff1)
#define SYSCR (*(volatile unsigned char *)0xfffff2)

#define ABWCR (*(volatile unsigned char *)0xffffec)
#define CSCR (*(volatile unsigned char *)0xffff5f)

#define TOER (*(volatile unsigned char *)0xffff90)
#define TOCR (*(volatile unsigned char *)0xffff91)
#define TSTR (*(volatile unsigned char *)0xffff60)
#define TSNC (*(volatile unsigned char *)0xffff61)
#define TMDR (*(volatile unsigned char *)0xffff62)
#define TFCR (*(volatile unsigned char *)0xffff63)
#define TCR0 (*(volatile unsigned char *)0xffff64)
#define TIOR0 (*(volatile unsigned char *)0xffff65)
#define TIER0 (*(volatile unsigned char *)0xffff66)
#define TSR0 (*(volatile unsigned char *)0xffff67)
#define TCNT0 (*(volatile unsigned short *)0xffff68)
#define TCNT0H (*(volatile unsigned char *)0xffff68)
#define TCNT0L (*(volatile unsigned char *)0xffff69)
#define GRA0 (*(volatile unsigned short *)0xffff6a)
#define GRA0H (*(volatile unsigned char *)0xffff6a)
#define GRA0L (*(volatile unsigned char *)0xffff6b)
#define GRB0 (*(volatile unsigned short *)0xffff6c)
#define GRB0H (*(volatile unsigned char *)0xffff6c)
#define GRB0L (*(volatile unsigned char *)0xffff6d)
#define TCR1 (*(volatile unsigned char *)0xffff6e)
#define TIOR1 (*(volatile unsigned char *)0xffff6f)
#define TIER1 (*(volatile unsigned char *)0xffff70)
#define TSR1 (*(volatile unsigned char *)0xffff71)
#define TCNT1 (*(volatile unsigned short *)0xffff72)
#define TCNT1H (*(volatile unsigned char *)0xffff72)
#define TCNT1L (*(volatile unsigned char *)0xffff73)
#define GRA1 (*(volatile unsigned short *)0xffff74)
#define GRA1H (*(volatile unsigned char *)0xffff74)
#define GRA1L (*(volatile unsigned char *)0xffff75)
#define GRB1 (*(volatile unsigned short *)0xffff76)
#define GRB1H (*(volatile unsigned char *)0xffff76)
#define GRB1L (*(volatile unsigned char *)0xffff77)

